"""First revision

Revision ID: d4867f3a4c0a
Revises:
Create Date: 2019-04-17 13:53:32.978401

"""
from alembic import op
import sqlalchemy as sa
from app.schemas.data_source import DataSourceTypeEnum

# revision identifiers, used by Alembic.
revision = "d4867f3a4c0a"
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
  # ### commands auto generated by Alembic - please adjust! ###
  op.create_table(
      "user",
      sa.Column("id", sa.String(), nullable=False),
      sa.Column("full_name", sa.String(), nullable=True),
      sa.Column("email", sa.String(), nullable=True),
      sa.Column("hashed_password", sa.String(), nullable=True),
      sa.Column("is_active", sa.Boolean(), nullable=True),
      sa.Column("is_superuser", sa.Boolean(), nullable=True),
      sa.PrimaryKeyConstraint("id"),
  )
  op.create_index(op.f("ix_user_email"), "user", ["email"], unique=True)
  op.create_index(op.f("ix_user_full_name"), "user", ["full_name"], unique=False)
  op.create_index(op.f("ix_user_id"), "user", ["id"], unique=False)
  # op.create_table(
  #     "item",
  #     sa.Column("id", sa.Integer(), nullable=False),
  #     sa.Column("title", sa.String(), nullable=True),
  #     sa.Column("description", sa.String(), nullable=True),
  #     sa.Column("owner_id", sa.Integer(), nullable=True),
  #     sa.ForeignKeyConstraint(["owner_id"], ["user.id"],),
  #     sa.PrimaryKeyConstraint("id"),
  # )
  # op.create_index(op.f("ix_item_description"), "item", ["description"], unique=False)
  # op.create_index(op.f("ix_item_id"), "item", ["id"], unique=False)
  # op.create_index(op.f("ix_item_title"), "item", ["title"], unique=False)

  op.create_table(
      "DATA_SOURCE",
      sa.Column("id", sa.Integer(), nullable=False),
      sa.Column("ref_id", sa.String(), unique=True, nullable=False),
      sa.Column("name", sa.String(), unique=False, nullable=False),
      sa.Column("desc", sa.Text(), nullable=True),
      sa.Column("type", sa.Enum(DataSourceTypeEnum), nullable=False),
      sa.Column("created_at", sa.DateTime(), nullable=False),
      sa.Column("updated_at", sa.DateTime(), nullable=False),
      sa.Column("created_by", sa.String(), nullable=False),
      sa.Column("updated_by", sa.String(), nullable=False),
      sa.PrimaryKeyConstraint("id"),
  )
  op.create_table(
      "DATA_SOURCE_PARAMETERS", sa.Column("id", sa.Integer(), nullable=False),
      sa.Column("ref_id", sa.String(), unique=True, nullable=False),
      sa.Column("name", sa.String(), nullable=False), sa.Column("value", sa.Text(), nullable=False),
      sa.Column("data_source_id", sa.Integer(), nullable=False), sa.PrimaryKeyConstraint("id"),
      sa.ForeignKeyConstraint(["data_source_id"], ["DATA_SOURCE.id"],
                              onupdate="CASCADE",
                              ondelete="CASCADE"))

  op.create_table(
      "MODEL", sa.Column("data_source_id", sa.Integer(), nullable=False),
      sa.Column("ref_id", sa.String(), unique=True, nullable=False),
      sa.Column("id", sa.String(), unique=True, nullable=False),
      sa.Column("name", sa.String(), nullable=False), sa.Column("type", sa.String(),
                                                                nullable=False),
      sa.Column("desc", sa.Text(), nullable=True),
      sa.Column("created_at", sa.DateTime(), nullable=False),
      sa.Column("updated_at", sa.DateTime(), nullable=False),
      sa.Column("created_by", sa.String(), nullable=False),
      sa.Column("updated_by", sa.String(), nullable=False), sa.PrimaryKeyConstraint("id"),
      sa.ForeignKeyConstraint(["data_source_id"], ["DATA_SOURCE.id"], ondelete="CASCADE"))
  op.create_table("MODEL_VERSION", sa.Column("model_id", sa.String(), nullable=False),
                  sa.Column("ref_id", sa.String(), unique=True, nullable=False),
                  sa.Column("id", sa.String(), unique=True, nullable=False),
                  sa.Column("deployment_name", sa.String(), nullable=True),
                  sa.Column("workflow_name", sa.String(), nullable=True),
                  sa.Column("version", sa.Integer(), nullable=False),
                  sa.Column("created_by", sa.String(), nullable=False),
                  sa.Column("created_at", sa.DateTime(), nullable=False),
                  sa.Column("updated_by", sa.String(), nullable=False),
                  sa.Column("updated_at", sa.DateTime(), nullable=False),
                  sa.Column("status", sa.String(), nullable=False),
                  sa.Column("status_message", sa.String(), nullable=True),
                  sa.Column("performance_metrics", sa.String(), nullable=True),
                  sa.Column("feature_significance", sa.String(), nullable=True),
                  sa.PrimaryKeyConstraint("id"),
                  sa.ForeignKeyConstraint(["model_id"], ["MODEL.id"], ondelete="CASCADE"))

  op.create_table(
      "MODEL_PARAMETERS", sa.Column("model_version_id", sa.String(), nullable=False),
      sa.Column("ref_id", sa.String(), unique=True, nullable=False),
      sa.Column("id", sa.Integer(), unique=True, nullable=False),
      sa.Column("parameter", sa.String(), nullable=False),
      sa.Column("value", sa.String(), nullable=False), sa.PrimaryKeyConstraint("id"),
      sa.ForeignKeyConstraint(["model_version_id"], ["MODEL_VERSION.id"], ondelete="CASCADE"))
  op.create_table(
      "FORECASTING_RESULT", sa.Column("id", sa.Integer(), unique=True, nullable=False),
      sa.Column("sku", sa.String(), nullable=False),
      sa.Column("model_version_id", sa.String(), nullable=False),
      sa.Column("date", sa.DateTime(), nullable=False),
      sa.Column("actual", sa.Integer(), nullable=True),
      sa.Column("forecast", sa.Integer(), nullable=True), sa.PrimaryKeyConstraint("id"),
      sa.ForeignKeyConstraint(["model_version_id"], ["MODEL_VERSION.id"], ondelete="CASCADE"))

  op.create_table("NOTIFICATION", sa.Column("source", sa.String(), nullable=False),
                  sa.Column("ref_id", sa.String(), unique=True, nullable=False),
                  sa.Column("id", sa.Integer(), unique=True, nullable=False),
                  sa.Column("user", sa.String(), nullable=False),
                  sa.Column("message", sa.Text(), nullable=False),
                  sa.Column("status", sa.String(), nullable=False),
                  sa.Column("severity", sa.String(), nullable=False),
                  sa.Column("created_at", sa.DateTime(), nullable=False),
                  sa.Column("updated_at", sa.DateTime(), nullable=False),
                  sa.Column("created_by", sa.String(), nullable=False),
                  sa.Column("updated_by", sa.String(), nullable=False),
                  sa.PrimaryKeyConstraint("id"))

  # ### end Alembic commands ###


#
# def downgrade():
#     # ### commands auto generated by Alembic - please adjust! ###
#     op.drop_index(op.f("ix_item_title"), table_name="item")
#     op.drop_index(op.f("ix_item_id"), table_name="item")
#     op.drop_index(op.f("ix_item_description"), table_name="item")
#     op.drop_table("item")
#     op.drop_index(op.f("ix_user_id"), table_name="user")
#     op.drop_index(op.f("ix_user_full_name"), table_name="user")
#     op.drop_index(op.f("ix_user_email"), table_name="user")
#     op.drop_table("user")
#     # ### end Alembic commands ###
